---
title: XRWebGLLayer()
slug: Web/API/XRWebGLLayer/XRWebGLLayer
tags:
  - API
  - AR
  - Constructor
  - Context
  - Create
  - Initialize
  - Layer
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRWebGLLayer
  - augmented
  - new
---
<p>{{APIRef("WebXR Device API")}}{{secureContext_header}}</p>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a> <code><strong>XRWebGLLayer()</strong></code> constructor creates and returns a new {{domxref("XRWebGLLayer")}} object, providing the linkage between the WebXR device and the WebGL graphics layer used to render the 3D scene.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>glLayer</em> = new XRWebGLLayer(<em>session</em>, <em>context</em>, <em>layerInit</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>session</code></dt>
 <dd>An {{domxref("XRSession")}} object specifying the WebXR session which will be rendered using the WebGL context.</dd>
 <dt><code>context</code></dt>
 <dd>A {{domxref("WebGLRenderingContext")}} or {{domxref("WebGL2RenderingContext")}} identifying the WebGL drawing context to use for rendering the scene for the specified WebXR session.</dd>
 <dt><code>layerInit</code> {{optional_inline}}</dt>
 <dd>
 <p>An object conforming to the {{domxref("XRWebGLLayerInit")}} dictionary, providing configuration options for the new <code>XRWebGLLayer</code>. The options available are:</p>
 {{page("/en-US/docs/Web/API/XRWebGLLayerInit", "Properties")}}</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A newly-created {{domxref("XRWebGLLayer")}} which links the specified {{domxref("XRSession")}} to the WebGL context given by <code>context</code>, which will be used as the renderer for the session. Any options specified in <code>layerInit</code> are used to tailor the rendering system's configuration.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>
 <p>The new <code>XRWebGLLayer</code> could not be created due to one of a number of possible state errors:</p>

 <ul>
  <li>The {{domxref("XRSession")}} specified by <code>session</code> has already been stopped.</li>
  <li>The specified WebGL context, <code>context</code>, <a href="/en-US/docs/Web/API/WebGLRenderingContext/isContextLost#Usage_notes">has been lost</a> for any reason, such as a GPU switch or reset.</li>
  <li>The specified <code>session</code> is immersive but the <code>context</code> is not WebXR compatible.</li>
 </ul>
 </dd>
 <dt><code>OperationError</code></dt>
 <dd>The resources (including memory buffers) needed for the layer to operate could not be allocated.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrwebgllayer-xrwebgllayer','XRWebGLLayer()')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRWebGLLayer.XRWebGLLayer")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebGL_API/Tutorial/Getting_started_with_WebGL">Getting started with WebGL</a></li>
 <li><a href="https://www.khronos.org/webgl/wiki/HandlingContextLost">Handling lost context in WebGL</a>: Khronos WebGL wiki</li>
</ul>
